using UnityEngine;

namespace Mod
{
  public class Mod
  {
    public static void Main()
    {
      CategoryBuilder.Create("MVD", "More Russians MVD!", ModAPI.LoadSprite("mvd.jpg"));

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[S] SOBR Soldier 1",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/sobr2ic.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("SOBR/SOBRSoldier1.png"),
          };
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[S] SOBR Soldier 2",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/sobr1ic.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("SOBR/SOBRSoldier2.png"),
          };
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Human"),
        NameOverride = "[S] SOBR Soldier 3",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/sobr3ic.png"),
        AfterSpawn = (Instance) =>
        {
          var person = Instance.GetComponent<PersonBehaviour>();

          var Head = Instance.transform.Find("Head").gameObject;

          Head.GetOrAddComponent<MultipleSpriteHumanBehaviour>().person = person;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Scale = 6;
          Head.GetComponent<MultipleSpriteHumanBehaviour>().Textures = new Texture2D[]
          {
            ModAPI.LoadTexture("SOBR/SOBRSoldier3.png"),
          };
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[S] ZSH 1-2M",
        NameToOrderByOverride = "",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/zhshic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SOBR/ZSh-1-2M.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[S] ZSH 1-2M (2)",
        NameToOrderByOverride = "",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/zhshic2.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SOBR/ZSh-1-2M2.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[S] SOBR TacticalMichHelmet",
        NameToOrderByOverride = "",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/tachic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SOBR/TacticalMichHelmet.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[S] SOBR Googles",
        NameToOrderByOverride = "",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/gogic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Head";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SOBR/Goggles.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[S] SOBR Beret",
        NameToOrderByOverride = "",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/beretic2.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SOBR/Beret.png", 5f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;
          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Stick"),
        NameOverride = "[S] SOBR Cap",
        NameToOrderByOverride = "",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/capic2.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SOBR/cap.png", 6f);
          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;

          armor.stabResistance = 25f;
          armor.armorPiece = "Head";
          armor.armorTier = 25;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[S] Kora 1-MK (1)",
        NameToOrderByOverride = "",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/kora2ic2.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SOBR/Kora 1-MK1.png", 6f);
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;


          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;
          armor.stabResistance = 30f;
          armor.armorPiece = "UpperBody";
          armor.armorTier = 55;

          Instance.FixColliders();
        }
      }
      );

      ModAPI.Register(
      new Modification()
      {
        OriginalItem = ModAPI.FindSpawnable("Rod"),
        NameOverride = "[S] Kora 1-MK (2)",
        NameToOrderByOverride = "",
        DescriptionOverride = "",
        CategoryOverride = ModAPI.FindCategory("MVD"),
        ThumbnailOverride = ModAPI.LoadSprite("icons/koraic.png"),
        AfterSpawn = (Instance) =>
        {
          Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Top";
          Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("SOBR/Kora 1-MK2.png", 6f);
          Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.01f;
          Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.01f;


          ArmorBehaviour armor = Instance.AddComponent<ArmorBehaviour>();
          armor.threepieces = false;
          armor.stabResistance = 30f;
          armor.armorPiece = "MiddleBody";
          armor.armorTier = 55;

          Instance.FixColliders();
        }
      }
      );
    }





    public class MultipleSpriteHumanBehaviour : MonoBehaviour
    {
      public Texture2D[] Textures = new Texture2D[0];
      public PersonBehaviour person;
      public int CurrentTexture = -2;
      public int Scale = 3;

      void Start()
      {
        SetTexture();
      }

      public void SetTexture()
      {
        if (Textures.Length == 0)
        return;

        if(CurrentTexture == -2)
        {
          CurrentTexture = UnityEngine.Random.Range(0, Textures.Length);
        }
        person.SetBodyTextures(Textures[CurrentTexture], null, null, Scale);
        for (int i = 0; i < person.Limbs.Length; i++)
        {
          person.Limbs[i].gameObject.GetComponent<PhysicalBehaviour>().RefreshOutline();

        }
      }
      }    }
    }
